package com.huigou.topsun.proofing.controller;

import com.huigou.context.Operator;
import com.huigou.context.OrgUnit;
import com.huigou.topsun.product.application.ProductLookedApplication;
import com.huigou.topsun.product.domain.ProductLooked;
import com.huigou.topsun.proofing.application.*;

import com.huigou.topsun.proofing.domain.model.proofingApply.ProofingApplyBaseInfo;
import com.huigou.topsun.proofing.domain.model.proofingApply.ProofingApplyLooked;
import com.huigou.topsun.proofing.domain.query.*;
import com.huigou.topsun.proofing.domain.vo.ProofingApplyBaseInfoVo;
import com.huigou.topsun.technology.application.TechnologyApplication;
import com.huigou.topsun.technology.application.TechnologyProcessApplication;
import com.huigou.topsun.technology.domain.query.TechnologyQueryRequest;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.common.BizBillStatus;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import javax.annotation.Resource;
import java.util.*;

@Controller
@ControllerMapping("/proofingApply")
public class ProofingApplyController extends CommonController {
    protected String getPagePath() {
        return "/biz/topsun/proofing/";
    }

    @Autowired
    ProofingApplyApplication proofingApplyApplication;
    @Autowired
    TechnologyApplication technologyApplication;
    @Autowired
    ProofingApplyLookedApplication proofingApplyLookedApplication;

    @Autowired
    ProductLookedApplication productLookedApplication;
    @Resource
    private TechnologyProcessApplication technologyProcessApplication;
    @Autowired
    ProofingApplyTechnologyApplication proofingApplyTechnologyApplication;
    @Autowired
    ProofingApplyProcessApplication proofingApplyProcessApplication;
    @Autowired
    ProofingMakeTechnologyApplication proofingMakeTechnologyApplication;
    @Autowired
    ProofingMakeProcessApplication proofingMakeProcessApplication;

    /**
     * 打样申请详情
     * @return
     */
        public String slicedProofingApplyList(){
            SDO sdo = this.getSDO();
            ProofingApplyQuery queryRequest = sdo.toQueryRequest(ProofingApplyQuery.class);
            Map<String, Object> map = proofingApplyApplication.slicedQuery(queryRequest);
            return toResult(map);
    }

    public String forwardProofingApplyList(){
        return forward("proofingApplyList");
    }


    /**
     * 打样表单页
     * @return
     */
    public String forwardProofingApply(){
        this.putAttribute("processDefinitionKey",ProofingApplyApplication.PROCESS_DEFINITION_KEY);
        this.putAttribute("procUnitId", "Apply");//定义流程环节的id
        ProofingApplyBaseInfo proofingApply = new ProofingApplyBaseInfo();
        proofingApply.setStatusId(BizBillStatus.APPLYING.getId());
        Operator operator = getOperator();//获取当前操作员的详情信息
        proofingApply.setDefaultValues(new OrgUnit(operator.getFullId(), operator.getFullName()));
        proofingApply.setProofingApplyNo(proofingApply.getBillCode()); //将生成的单号赋予实体类对应字段
        return forward("proofingApply",proofingApply);
    }

    /**
     * 工作流审核跳转页面
     * @return
     */
    public String showProofingApply() {
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
        ProofingApplyBaseInfo proofingApply = proofingApplyApplication.loadProofingApplyById(id);
        ProofingApplyLooked proofingApplyLooked = proofingApplyLookedApplication.findByProofingApplyId(proofingApply.getProofingApplyId());
        ProofingApplyBaseInfoVo vo =new ProofingApplyBaseInfoVo();
        BeanUtils.copyProperties(proofingApply,vo);
        BeanUtils.copyProperties(proofingApplyLooked,vo);
        return forward("proofingApply", vo);
    }

    /**
     * 根据产品编号获取外观详情
     * @return
     */
    public String queryProductLooked(){
        SDO sdo = this.getSDO();
        String productId = sdo.getString("productId");
        ProductLooked productLooked = new ProductLooked();
        productLooked.setProductId(Long.valueOf(productId));
        ProductLooked newProductLooked = productLookedApplication.getProductLookedByEntity(productLooked);
        return toResult(newProductLooked);
    }



    /**
     * 展示工艺
     * @return
     */
    public String slicedTechnologyList(){
        SDO sdo = this.getSDO();
        TechnologyQueryRequest queryRequest = sdo.toQueryRequest(TechnologyQueryRequest.class);
        ProofingApplyTechnologyQueryRequest proofingApplyTechnologyQueryRequest = sdo.toQueryRequest(ProofingApplyTechnologyQueryRequest.class);
        ProofingMakeTechnologyQueryRequest proofingMakeTechnologyQueryRequest = sdo.toQueryRequest(ProofingMakeTechnologyQueryRequest.class);
        Map<String, Object> map = new HashMap<>();
        //判断需要展示产品工艺还是打样表中工艺
        if(proofingApplyTechnologyQueryRequest.getProofingApplyId()!=null&&!proofingApplyTechnologyQueryRequest.getProofingApplyId().equals("")){
            map = proofingApplyTechnologyApplication.slicedProofingApplyTechnology(proofingApplyTechnologyQueryRequest);
        }else if(queryRequest.getProductId()!=null&&!queryRequest.getProductId().equals("")){
            map = technologyApplication.slicedTechnologyList(queryRequest);
        }else if(proofingMakeTechnologyQueryRequest.getProofingMakeId()!=null&&!"".equals(proofingMakeTechnologyQueryRequest.getProofingMakeId())){
            map=proofingMakeTechnologyApplication.slicedProofingMakeTechnology(proofingMakeTechnologyQueryRequest);
        }
        return toResult(map);
    }


    /**
     * 展示工序
     * @return
     */
    public String slicedTechnologyProcessList(){
        SDO sdo = this.getSDO();
        String technologyId = sdo.getString("technologyId");
        ProofingApplyProcessQueryRequest proofingApplyProcessQueryRequest = sdo.toQueryRequest(ProofingApplyProcessQueryRequest.class);
        ProofingMakeProcessQueryRequest proofingMakeProcessQueryRequest = sdo.toQueryRequest(ProofingMakeProcessQueryRequest.class);
        //判断需要展示产品工序还是打样表中工序
        if(proofingApplyProcessQueryRequest.getProofingApplyTechnologyId()!=null&&!proofingApplyProcessQueryRequest.getProofingApplyTechnologyId().equals("")){
           return toResult(proofingApplyProcessApplication.slicedProofingApplyProcess(proofingApplyProcessQueryRequest));
        }else if(technologyId!=null&&!technologyId.equals("")){
            return packGridDataAndResult(technologyProcessApplication.slicedTechnologyProcessList(technologyId));
        }else  if(proofingMakeProcessQueryRequest.getProofingMakeTechnologyId()!=null&&!proofingMakeProcessQueryRequest.getProofingMakeTechnologyId().equals("")){
            return toResult(proofingMakeProcessApplication.slicedProofingMakeProcess(proofingMakeProcessQueryRequest));
        }
        return toResult(null);
    }

}
